from gocept.directory2.domain import Domain, User
import gocept.testing.assertion
import transaction


class DomainMixin(gocept.testing.assertion.Ellipsis):

    def create_domain(self):
        user = User.create(id=100, name='ctheune')
        transaction.commit()
        domain = Domain.create(name='flyingcircus.io', uid=user.id)
        return domain, user

    def create_domains_with_subdomains(self):
        domain, user = self.create_domain()
        Domain.create(
            name='www.flyingcircus.io', uid=user.id, subdomain_of=domain)
        other_domain = Domain.create(name='gocept.de', uid=user.id)
        Domain.create(
            name='www.gocept.de', uid=user.id, subdomain_of=other_domain)
