import gocept.directory2.api
import gocept.directory2.testing
import gocept.httpserverlayer.wsgi
import gocept.testing.assertion
import unittest
import xmlrpclib


class APINoAuthApplication(gocept.directory2.api.APIApplication):

    def configure_auth(self):
        # We do not want authentication/authorization here.
        pass

APPLICATION_LAYER_NO_AUTH = gocept.directory2.testing.ApplicationLayer(
    APINoAuthApplication)
WSGI_LAYER_NO_AUTH = gocept.directory2.testing.WSGILayer(
    bases=(APPLICATION_LAYER_NO_AUTH,), name='WSGILayerNoAuth')
HTTP_LAYER_NO_AUTH = gocept.httpserverlayer.wsgi.Layer(
    bases=(WSGI_LAYER_NO_AUTH,), name='HTTPLayerNoAuth')


APPLICATION_LAYER = gocept.directory2.testing.ApplicationLayer(
    gocept.directory2.api.APIApplication)
WSGI_LAYER = gocept.directory2.testing.WSGILayer(
    bases=(APPLICATION_LAYER,), name='WSGILayer')
HTTP_LAYER = gocept.httpserverlayer.wsgi.Layer(
    bases=(WSGI_LAYER,), name='HTTPLayer')


class XMLRPCTestCase(unittest.TestCase,
                     gocept.testing.assertion.String,
                     gocept.testing.assertion.Exceptions):

    layer = HTTP_LAYER_NO_AUTH

    def xmlrpc(self, path, username=None, password=None):
        if username and password:
            auth = '%s:%s@' % (username, password)
        else:
            auth = ''
        url = 'http://%s%s%s' % (auth, self.layer['http_address'], path)
        return xmlrpclib.ServerProxy(url)
