from sqlalchemy import Column, Integer, String, Text
from sqlalchemy.orm import validates
import gocept.directory2.db


class Permission(gocept.directory2.db.Object):

    __tablename__ = 'permissions'

    id_number = Column(Integer)
    name = Column(String, unique=True)
    description = Column(Text)

    @validates('id_number')
    def check_id_number_unique(self, _, id_number):
        # XXX can we refactor this to make better use of database uniqueness
        # checks?
        from .resourcegroup import ResourceGroup
        if ResourceGroup.query().filter_by(id_number=id_number).count():
            raise AssertionError(
                'Permission id already used for an existing resource group.')
        if Permission.query().filter(
                Permission.id_number == id_number,
                Permission.id != self.id).count():
            raise AssertionError(
                'Permission id already used for an existing permission.')
        return id_number
